#include <windows.h>
#include <sapi.h>

#pragma comment(lib, "ole32.lib")
#pragma comment(lib, "sapi.lib")

#define DLLEXPORT				_declspec(dllexport)

ISpVoice * gpVoice = NULL;

BOOL WINAPI DllMain(HINSTANCE hinstDLL, DWORD fdwReason, LPVOID lpvReserved)
{
        switch (fdwReason) {
                case DLL_PROCESS_ATTACH:
                        if (FAILED(CoInitialize(NULL))) {
                                return FALSE;
                        }
                        if (FAILED(CoCreateInstance(CLSID_SpVoice, NULL, CLSCTX_ALL, IID_ISpVoice, (void **)&gpVoice))) {
                                return FALSE;
                        }
                        if (!gpVoice) return FALSE;
                        break;
                case DLL_PROCESS_DETACH:
                        /*
                        if (gpVoice) gpVoice->Release();
                        */
                        gpVoice = NULL;
                        CoUninitialize();
                        break;
                default:
                        break;
        }
        return TRUE;
}

extern "C" BOOL DLLEXPORT __cdecl MT_SpeechText(char const * text, BOOL async)
{
        WCHAR * msg;
        BOOL ret;
        int len;
        DWORD dwFlags;

        len = strlen(text) + 1;
        msg = (WCHAR*)malloc(len * sizeof(WCHAR));

        MultiByteToWideChar(CP_ACP, 0, text, len, msg, len);
        if (async) {
                dwFlags = SPF_ASYNC;
        } else {
                dwFlags = SPF_DEFAULT;
        }

        if (FAILED(gpVoice->Speak(msg, dwFlags, NULL))) {
                ret = FALSE;
        } else {
                ret = TRUE;
        }

		free(msg);
        return ret;
}

extern "C" BOOL DLLEXPORT __cdecl SpeechText(const char* text)
{
	return MT_SpeechText(text, FALSE);
}

extern "C" BOOL DLLEXPORT __cdecl SpeechTextAsync(const char* text)
{
	return MT_SpeechText(text, TRUE);
}
